#ifndef _HASH_HPP_
#define _HASH_HPP_

#include <iostream.h>
#include <string.h>

//these are only shortcuts if you are to lasy to make your own funcs
#define HASH_NUMEL_SMALL  47    
#define HASH_NUMEL_MEDIUM 821
#define HASH_NUMEL_BIG    2039

unsigned int HASH_FUNC_SMALL(array<int>& mat)  {unsigned int c1,cnt=0;
	for (c1=0;c1<mat.numel;c1++) cnt+=mat[c1]; return cnt%HASH_NUMEL_SMALL; }
unsigned int HASH_FUNC_MEDIUM(array<int>& mat) {unsigned int c1,cnt=0;
	for (c1=0;c1<mat.numel;c1++) cnt+=mat[c1]; return cnt%HASH_NUMEL_MEDIUM; }
unsigned int HASH_FUNC_BIG(array<int>& mat)    {unsigned int c1,cnt=0;
	for (c1=0;c1<mat.numel;c1++) cnt+=mat[c1]; return cnt%HASH_NUMEL_BIG;}

// !!! class comp has to have an == operator to it !!!
	
template <class comp,class type> class bucket {
	public:
		comp key;
		type data;
};

template <class comp,class type> class hash {
	public:
		hash<comp,type>(void);
		hash<comp,type>(int n,unsigned int (*f)(comp));		//init with # of buckets and hash function (ptr)
		~hash<comp,type>(void);
		bool find(comp key,type &data);										//finds element by key and returns data byref otherwise false
		bool store(comp key,type &data);									//stores object with key if key does not exist already else false and byref occupyer data
		bool prior(comp key,type &data);									//appends object if key does not exist, otherwise replace curr data with "priority" data
		bool remove(comp key);														//removes existing entry with key otherwise false (alternatively make it return data!!!)
		bool apply(bool (*f)(type));
		bool apply(bool (*f)(comp,type));
		array<linked<bucket<comp,type> >*> *table;
		int numel;																				//DOES NOT ALWAYS!!! report the number of entries
	private:
		unsigned int (*func)(comp);
};
//constructors-------------------------------------------------------------
template <class comp,class type> hash<comp,type>::hash(void) {table=NULL;};
template <class comp,class type> hash<comp,type>::hash(int n,unsigned int (*f)(comp)) {
	table=new array<linked<bucket<comp,type> >*>(1,&n,NULL);
	for (int c1=0;c1<table->numel;c1++)
		table->data[c1]=new linked<bucket<comp,type> >();
	func=f;
	numel=0;
}
template <class comp,class type> hash<comp,type>::~hash(void) {
	if (table) {
		for (int c1=0;c1<table->numel;c1++) delete table->data[c1];
		delete table;
	}
}
template <class comp,class type> bool hash<comp,type>::find(comp key,type &data) {
	unsigned int n=func(key)%table->numel;
	bucket<comp,type> b;
	while (table->data[n]->token(b))
		if (b.key==key) {			
			data=b.data;
			table->data[n]->reset();
			return true;
		}
	return false;
}
template <class comp,class type> bool hash<comp,type>::store(comp key,type &data) {
	unsigned int n=func(key)%table->numel;
	bucket<comp,type> b;
	while (table->data[n]->token(b))
		if (b.key==key) {
			data=b.data; //ferry
			table->data[n]->reset();
			return false;
		}
	b.key=key; b.data=data;
	table->data[n]->append(b);
	numel++;
	return true;
}
template <class comp,class type> bool hash<comp,type>::prior(comp key,type &data) {
	unsigned int n=func(key)%table->numel;
	bucket<comp,type> b;
	while (table->data[n]->token(b))
		if (b.key==key) {
			b.data=data;
			table->data[n]->next[2]->data=b;
			table->data[n]->reset();
			return false;
		}
	b.key=key; b.data=data;
	table->data[n]->append(b);
	numel++;
	return true;
}
//this function can be called within another linked list tokenizer:-)
//behaviour is undefined when current gets removed.
//current can be removed from outside with
//while (hash->...->token(bucket)) hash->table[c1]->remove();
template <class comp,class type> bool hash<comp,type>::remove(comp key) {
	unsigned int n=func(key)%table->numel;
	bucket<comp,type> b;
	ntree<bucket<comp,type> > *pre=table->data[n]->next[2]; //due to this
	table->data[n]->reset();
	while (table->data[n]->token(b))
		if (b.key==key) {
			table->data[n]->remove();
			table->data[n]->reset();
			numel--;
			table->data[n]->next[2]=pre; //this
			return true;
		}
	table->data[n]->next[2]=pre; //and this
	return false;
}
//LATER: Merge find and remove and have find(HASH_FIND/HASH_REMOVE,...);
template <class comp,class type> bool hash<comp,type>::apply(bool (*f)(type)) {	
	bucket<comp,type> b;
	for (int c1=0;c1<table->numel;c1++)
		while (table->data[c1]->token(b)) 
			if (!f(b.data)) {
				table->data[c1]->reset();
				return false;
			}
	return true;
}
template <class comp,class type> bool hash<comp,type>::apply(bool (*f)(comp,type)) {
	bucket<comp,type> b;
	for (int c1=0;c1<table->numel;c1++)
		while (table->data[c1]->token(b)) 
			if (!f(b.key,b.data)) {
				table->data[c1]->reset();
				return false;
			}
	return true;
}

template <class comp,class type> ostream& operator<< (ostream& os,hash<comp,type>& h) {
	int c1,cnt,glob=0;
	bucket<comp,type> b;
	os << "h[" << h.table->numel << "]" << endl;
	//if (h.table->numel<100) {
		for (c1=0;c1<h.table->numel;c1++) {
		//for (c1=20;c1<40;c1++) {
			os << "-----{@" << c1 << ":";		
			while (h.table->data[c1]->token(b)) os << ",[" << b.key << "," << b.data << "]";
			os << "}" << endl;
		}
	//}	
	os << " <";
	for (c1=0;c1<h.table->numel;c1++) {
		cnt=0;
		while (h.table->data[c1]->token(b)) cnt++;
		glob+=cnt;
		if (h.table->numel<300) os << cnt << " ";			
	}
	os << "[=" << glob << "]>" << endl;
	return os;
}

#endif