#include <math.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <iostream.h>
#include "../matrix.hpp"
#include "../ntree.hpp"
#include "../hash.hpp"
#define MESH_IO				//include mesh text file input and output
#include "../mesh.hpp"

int main (int argc,char** argv) {
	int c1;
	array_output=false;	
	if (argc==1) {		
		cout << "Volumetric (and surface) mesh subdivider. available at www.hakenberg.de" << endl;
		cout << endl;	
		cout << "usage: mesh3d filename [options]\n";
		cout << "options: arbitrary sequence of the characters\n";
		cout << "         b - add boundary\n";
		cout << "         l - linear subdivision\n";
		cout << "         s - normal subdivision\n";
		cout << "operations are performed in order of appearance;\n";
		cout << "when done, new mesh is stored in filename.out.\n";
		cout << endl;
		cout << "example: mesh3d sample.txt b l s s" << endl;
		cout << "hit ENTER to continue..." << endl;
		char c=getchar();
	} else {
		mesh_init(); //call once initially, before using any mesh function
		char fnc[80];
		mesh<float> msh(0); //default value. When adding vertices dimensionality is adjusted
		printf("load mesh: %s\n",argv[1]);
		msh.addFile(MESH_TXT,argv[1]);
		msh.content(fnc);
		printf("mesh: %s\n",fnc);
		for (c1=2;c1<argc;c1++) {
			if (*argv[c1]=='b') {
				printf("add boundary\n");
				msh.addBoundary();
			}
			if (*argv[c1]=='l') {
				printf("linear subdivision\n");
				msh.subdivide(MESH_LINEAR);
			}
			if (*argv[c1]=='s') {
				printf("normal subdivision\n");
				msh.subdivide(MESH_NORMAL);
			}		
		}		
		sprintf(fnc,"%s.out",argv[1]);		
		printf("store in: %s\n",fnc);
		msh.storeTxt(fnc);		
		msh.content(fnc);
		printf("mesh: %s\n",fnc);
	}	
	return 0;
}